
// This code was produced by Maphoon 2008.
// Code of struct token:


#include "token.h"


bool token::iswellformed( ) const
{
   switch( type )
   {
   case tkn__recover:
   case tkn__defaultred:
   case tkn_L1:
   case tkn_S:
   case tkn_L2:
   case tkn_L3:
   case tkn_T:
   case tkn_U2:
   case tkn_a:
      if( xx. size( ) >= 1 ) return false;
      return true;
   case tkn_U1:
      if( xx. size( ) < 4 ) return false;
      return true;
   }
   return false; // Because of unknown type.
}


// If you see an insane error message originating from
// this point, then the most probably reason is that
// one of the attribute types has no print function defined.

std::ostream& operator << ( std::ostream& stream, const token& t )
{
   switch( t. type )
   {
   case tkn__recover:
      stream << "_recover( "; break;
   case tkn__defaultred:
      stream << "_defaultred( "; break;
   case tkn_L1:
      stream << "L1( "; break;
   case tkn_S:
      stream << "S( "; break;
   case tkn_L2:
      stream << "L2( "; break;
   case tkn_L3:
      stream << "L3( "; break;
   case tkn_U1:
      stream << "U1( "; break;
   case tkn_T:
      stream << "T( "; break;
   case tkn_U2:
      stream << "U2( "; break;
   case tkn_a:
      stream << "a( "; break;
   default:
      stream << "UNKNOWNTOKEN( ";
   }

   unsigned int arg = 0;
   unsigned int arginlist;

   arginlist = 0;
   for( std::list< double > :: const_iterator
           p = t. xx. begin( );
           p != t. xx. end( );
           ++ p )
   {
      if( arg != 0 && arginlist == 0 ) stream << "; ";
      if( arg != 0 && arginlist != 0 ) stream << ", ";
      stream << *p;
      ++ arg;
      ++ arginlist;
   }

   stream << " )";
   return stream;
}


